/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __GB02_PVT__
#define __GB02_PVT__
#include "gb-peripherals-common.h"

#ifndef BIT
#define BIT(x) (1 << (x))
#endif

#define GB02MAC1631 0x82400000
#define GB02MAC1633 0x80000000

#define GB02MAC1636 GB02MAC698
#define GB02MAC1637 GB02MAC1059 // 0x82400000

/* 75 25 typical conditions steady DOUT values */
#define DOUT75std 2874LL
#define DOUT25std 2761LL

/* assumes 75 and 25 degrees actual conditions DOUT values, for now*/
#define DOUT75act 2902LL
#define DOUT25act 2784LL

#define DOUTstd 2067
#define Vref 1170 // mV
#define GB02MAC1643 3000
#define GB02MAC1645 2000
#define D1 ((3 * DOUT75act - DOUT25act) / 2)
#define D2 ((DOUT75act + DOUT25act) / 2)
#define D3 ((3 * DOUT25act - DOUT75act) / 2)
#define D4 (DOUT25act - (DOUT75act - DOUT25act) * 9 / 10)

#define GB02MAC1647 (0x00)

#define GB02MAC1650 20
#define GB02MAC1652(x) (((x)&0x7ff) << GB02MAC1650) // default 3000
#define GB02MAC1654 8
#define GB02MAC1656(x) (((x)&0x7ff) << GB02MAC1654) // default 2500
#define GB02MAC1657 BIT(7)															 // 1: power up  0:power down --default 1
#define GB02MAC1660 1
#define GB02MAC1663 0
#define PVT_RESETn_MASK BIT(6) // low active ,default 0
#define GB02MAC1665 0
#define GB02MAC1668 1

#define GB02MAC1671 BIT(5) // 1:temperature 0 :voltage default 1
#define GB02MAC1674 1
#define GB02MAC1677 0
#define TEST_EN_MASK BIT(4)		   // IP test enable signal ,defaul 0
#define BAND_GAP_TRIM(x) ((x)&0x7) // bandgap trim signal ,default 4'b0111

#define GB02MAC1681 (0x04)

#define GB02MAC1684 12
#define GB02MAC1687(x) (((x)&0x7ff) << GB02MAC1684) // default 3000
#define GB02MAC1690 0
#define GB02MAC1693(x) (((x)&0x7ff) << GB02MAC1690) // default 2500

#define GB02MAC1696 (0x08)
#define GB02MAC1699 12
#define GB02MAC1702(x) (((x)&0x7ff) << GB02MAC1699) // default 3000
#define GB02MAC1704 0
#define GB02MAC1705(x) (((x)&0x7ff) << GB02MAC1704) // default 2500

#define GB02MAC1708 (0x0C)

#define GB02MAC1710 24
#define GB02MAC1712(x) (((x)&0xff) << GB02MAC1710) // default 8'd31

#define GB02MAC1716 12
#define GB02MAC1718(x) (((x)&0x7ff) << GB02MAC1716) // default 3000
#define GB02MAC1720 0
#define GB02MAC1722(x) (((x)&0x7ff) << GB02MAC1720) // default 2500

#define GB02MAC1724 (0x10)
#define GB02MAC1726 BIT(3) // write 1 clear default 0
#define GB02MAC1728 BIT(2)	 // write 1 clear default 0
#define GB02MAC1730 BIT(1) // write 1 clear default 0
#define GB02MAC1732 BIT(0)	 // write 1 clear default 0

#define GB02MAC1735 (0x14)

#define GB02MAC1737 BIT(19)
#define GB02MAC1739 BIT(18)
#define GB02MAC1741 BIT(17)
#define GB02MAC1743 BIT(16)
#define GB02MAC1745 BIT(15)
#define GB02MAC1746 BIT(14)
#define GB02MAC1747 BIT(13)
#define GB02MAC1748 BIT(12)
#define DOUT(x) ((x)&0xfff)

#ifdef CONFIG_MCU_PVT
int GB02FUNC1188(struct GB02STR37 *gb_dev, struct GB02STR72 *peri_info);
void GB02FUNC1189(struct GB02STR72 *peri_info);
int GB02FUNC1165(void);
#else
static inline int GB02FUNC1188(struct GB02STR37 *gb_dev, struct GB02STR72 *peri_info)
{
	return 0;
}
static inline void GB02FUNC1189(struct GB02STR72 *peri_info)
{
	return;
}
static inline int GB02FUNC1165(void)
{
	return 0;
}
#endif
#endif
