#ifndef __GB02_PERIPHERALS_COMMON__
#define __GB02_PERIPHERALS_COMMON__
#define DEBUG
/*global*/
#include <linux/io.h>
#ifndef CONFIG_SW64
#include <asm-generic/io.h>
#endif
#include <linux/i2c.h>
#include "common/gb_common.h"
#define GB02_VENDER_ID 0x8510
#define GB02_DEVICE_ID 0x0201

#define GB02_BAR_NUM 6
#define GB02_MCU_ACCESS_BAR 0
#define GB02_SYSTEM_PERIPHERAL_BAR 1
#define GB02_DDR_BAR 2
#define GB02_SYS_CFG_REG_BAR 4
#define GB02_PCIE_ROM_BAR 5

#define CFG_MCU_XIP_ADDR_OFFSET 0xd0c
#define CFG_SYS_PERI_ADDR_OFFSET 0xd10
#define MCU_SYSCTRL_BASE_ADDR 0x60000000
#define INT_CONTROLLER_BASE_ADDR 0x80000000
#define INT_CONTROLLER_OFFSET 0x403000
#define MCU_PERI_ADDR_IN_BAR0 0x3000000
#define MCU_OWN_PERI_ADDR_BASE 0xf0000000
#define MCU_SPI1_PERI_ADDR_OFFSET 0x52000
#define GB02_MCU_SYS_CLK		(3200 * 1000 / 12) /*in KHz*/
/*#define GB02_MCU_SYS_CLK (5333)*/ /* in KHz  */

#define MCU_PWM_PERI_NUM (2)
#define MCU_PWM_PERI_ADDR_BASE 0x60000
#define MCU_PWM_PERI_OFFSET 0x1000

#define PLATFORM_UART_DEVICE_NAME "gb02-mcu-uart"
#define PLATFORM_SPI_DEVICE_NAME "gb02-mcu-spi"
#define PLATFORM_PWM_DEVICE_NAME "gb02-mcu-pwm"
#define PLATFORM_GPIO_PWM_DEVICE_NAME "gb02-mcu-gpio-pwm"
#define PLATFORM_I2C_DEVICE_NAME "gb02-mcu-i2c"
#define PLATFORM_LGPIO_DEVICE_NAME "gb02-mcu-gpio"
#define PLATFORM_PVT_DEVICE_NAME "gb02-pvt-thermal"
#define PLATFORM_FREQ_DEVICE_NAME "gpu_freq"
#define PLATFORM_FAN_DEVICE_NAME "gb02-fan"
#define DEVICE_ID0 0
#define DEVICE_ID1 1
#define DEVICE_ID2 2
#define DEVICE_ID3 3
#define DEVICE_ID4 4
#define DEVICE_ID5 5

/*uart resource*/
#define MCU_UART0_PERI_ADDR_BASE 0x20000
#define GB02_UART0_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_UART0_PERI_ADDR_BASE)
#define MCU_UART1_PERI_ADDR_BASE 0x22000
#define GB02_UART1_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_UART1_PERI_ADDR_BASE)
#define MCU_UART_PERI_ADDR_OFST 0x2000

/*i2c resource*/
#define MCU_I2C0_PERI_ADDR_BASE 0x30000
#define GB02_I2C0_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_I2C0_PERI_ADDR_BASE)
#define MCU_I2C1_PERI_ADDR_BASE 0x32000
#define GB02_I2C1_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_I2C1_PERI_ADDR_BASE)
#define MCU_I2C2_PERI_ADDR_BASE 0x34000
#define GB02_I2C2_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_I2C2_PERI_ADDR_BASE)
#define MCU_I2C3_PERI_ADDR_BASE 0x36000
#define GB02_I2C3_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_I2C3_PERI_ADDR_BASE)
#define MCU_I2C_PERI_ADDR_OFST 0x2000

/*spi resource*/
#define MCU_SPI_PERI_ADDR_BASE 0x52000
#define GB02_SPI_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_SPI_PERI_ADDR_BASE)

/*pwm resource*/
#define MCU_PWM0_PERI_ADDR_BASE 0x60000
#define GB02_PWM0_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_PWM0_PERI_ADDR_BASE)
#define MCU_PWM1_PERI_ADDR_BASE 0x61000
#define GB02_PWM1_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_PWM1_PERI_ADDR_BASE)

/*pvt resource*/

/*lgpio resource*/
#define MCU_LGPIO_PERI_ADDR_BASE 0x80000
#define GB02_LGPIO_RESOURCE_START 0xf0080000
#define GB02_LGPIO_RESOURCE_END 0xf0085fff
#define MCU_LGPIO0_PERI_ADDR_BASE 0x80000
#define GB02_LGPIO0_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_LGPIO0_PERI_ADDR_BASE)
#define MCU_LGPIO1_PERI_ADDR_BASE 0x81000
#define GB02_LGPIO1_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_LGPIO1_PERI_ADDR_BASE)
#define MCU_LGPIO2_PERI_ADDR_BASE 0x82000
#define GB02_LGPIO2_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_LGPIO2_PERI_ADDR_BASE)
#define MCU_LGPIO3_PERI_ADDR_BASE 0x83000
#define GB02_LGPIO3_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_LGPIO3_PERI_ADDR_BASE)
#define MCU_LGPIO4_PERI_ADDR_BASE 0x84000
#define GB02_LGPIO4_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_LGPIO4_PERI_ADDR_BASE)
#define MCU_LGPIO5_PERI_ADDR_BASE 0x85000
#define GB02_LGPIO5_RESOURCE_START (MCU_OWN_PERI_ADDR_BASE + MCU_LGPIO5_PERI_ADDR_BASE)


#define GB02_IRQ_VEC_NUM 16
/* BAR0 register */
#define SYSCTL_CLK_DIV_OFFSET 0x4
#define SYSCTL_IOFUNC_OFFSET 0x10
#define SYSCTL_BOOT_MODE_OFFSET 0x14
#define BOOT_MODE_MCU2PCIE_SW_INT BIT(4)
#define SYSCTL_IOCTL_BASE_OFFSET 0x18
#define SYSCTL_SPARE0_OFFSET 0x200
#define SYSCTL_SPARE1_OFFSET 0x204
#define SYSCTL_SPARE2_OFFSET 0x208
#define SYSCTL_SPARE2_HOT_RESET 0x5a
#define SYSCTL_SPARE3_OFFSET 0x20c
#define SYSCTL_SPARE3_REBOOT_VALUE 0x5a
#define SYSCTL_SPARE4_OFFSET 0x210
#define SYSCTL_SPARE4_MCU_BOOT_FINISHED_VALUE 0x55
#define SYSCTL_SPARE5_OFFSET 0x214
#define SYSCTL_SPARE6_OFFSET 0x218
#define SYSCTL_SPARE7_OFFSET 0x21c

/* BAR1 register */
#define INTC_IRQ_INTEN_L_OFFSET 0x0
#define INTC_IRQ_INTEN_H_OFFSET 0x4
#define INTC_IRQ_INTMASK_L_OFFSET 0x8
#define INTC_IRQ_INTMASK_H_OFFSET 0xc
#define INTC_IRT_RAWSTATUS_L_OFFSET 0x18
#define INTC_IRT_RAWSTATUS_H_OFFSET 0x1c
#define INTC_IRT_STATUS_L_OFFSET 0x20
#define INTC_IRT_STATUS_H_OFFSET 0x24

#define PERIPHERALS_DEVICE_NAME_LEN 64
#define PERIPHERALS_DEVICE_NUM 32
typedef struct gb_device gb_device;

struct gb02_pcie_dev {
	struct pci_dev *pdev;
};

struct gb02_mcu_peripherals_info {
	unsigned char mcu_peripherals_device_name[PERIPHERALS_DEVICE_NAME_LEN];
	unsigned int mcu_peripherals_device_id;
	unsigned int peri_offset_address;
	int gpio_num; //for gpio pwm
	int (*gb02_peri_ip_drv_init)(struct gb_device *, struct gb02_mcu_peripherals_info *);
	void (*gb02_peri_ip_drv_exit)(struct gb02_mcu_peripherals_info *);
	int (*gb02_peri_ip_drv_suspend)(struct gb02_mcu_peripherals_info *);
	int (*gb02_peri_ip_drv_resume)(struct gb02_mcu_peripherals_info *);
	void *priv;
};

struct gb02_i2c_device {
	struct i2c_board_info board_info;
	u8 bus_id;
	int (*i2c_driver_init)(struct i2c_client *);
	void (*i2c_driver_exit)(struct i2c_client *);
	struct i2c_client * client;
	bool enable;
};

struct gb02_pwm_device {
	int device_id;
	bool gpio_pwm;
	unsigned char *name;
	bool enable;
	int num_connector;
	int (*pwm_driver_init)(struct gb_device *, struct gb02_mcu_peripherals_info *, struct gb02_pwm_device *pwm_dev);
	void (*pwm_driver_exit)(struct gb02_mcu_peripherals_info *);
	int (*pwm_driver_suspend)(struct gb02_mcu_peripherals_info *);
	int (*pwm_driver_resume)(struct gb_device *gbdev, struct gb02_mcu_peripherals_info *);
};

static inline void base_reg_write(u32 val, void __iomem *regbase, u32 offset)
{
	iowrite32(val, regbase + offset);
	gb_printf(KERN_DEBUG, "REG: write 0x%x value: 0x%x\n", offset, val);
}

static inline u32 base_reg_read(void __iomem *regbase, u32 offset)
{
	u32 val;

	val = ioread32(regbase + offset);
	gb_printf(KERN_DEBUG, "REG: read 0x%x value: 0x%x\n", offset, val);

	return val;
}
#ifdef CONFIG_MCU_PERI
void gb_peripherals_init(struct gb_device *gbdev);
void gb_peripherals_exit(struct gb_device *gbdev);
int gb_peripherals_suspend(struct gb_device *gbdev);
int gb_peripherals_resume(struct gb_device *gbdev);
#else
static inline void gb_peripherals_init(struct gb_device *gbdev)
{
	return;
}

static inline void gb_peripherals_exit(struct gb_device *gbdev)
{
	return;
}

static inline int gb_peripherals_suspend(struct gb_device *gbdev)
{
	return 0;
}

static inline int gb_peripherals_resume(struct gb_device *gbdev)
{
	return 0;
}
#endif
#endif
