/*
 * Copyright (C) Sietium Electronics Co.Ltd
 */

#ifndef	__GB_DEBUGFS_H__
#define	__GB_DEBUGFS_H__

#define CONFIG_GB_DEBUGFS
#define PARAM_COUNT 4

/*dc info*/
#define DE_COUNT			285 /*de:0x00000~0x00474*/
#define SE_COUNT			85 /*dc:0x08000~0x08154*/
#define DC_STATUS_COUNT			6  /*dc:0x0c000~0x0c018*/
#define DC_ID_COUNT			11 /*dc:0x0FFD0~0x0fffc*/
#define DCS_COUNT			4 /*dcs:0x10000~0x01ffff*/
#define DE_OFFSET_END			0x00474
#define SE_OFFSET_START			0x08000
#define DC_STATUS_OFFSET_START		0x0c000
#define DC_ID_OFFSET_START		0x0ffd0
#define DC_OFFSET_END			0x0fffc
#define DCS_OFFSET_START		0x10000
#define LG_STRIDE			0x318
#define LG_PTR_LOW			0x31c

/*dc cmd*/
#define GB_DBG_DC_READ			0x01
#define GB_DBG_DC_WRITE			0x02
#define GB_DBG_DC_FLUSH			0x03
#define GB_DBG_DC_REGDATA		0x04
#define GB_DBG_FILE_TO_FB		0x05
#define GB_DBG_DC_READ_FB		0x06

#define DC_FB_TEST_FILE			"/data/1920_1080.argb"
#define DC_REG_DATA_FILE		"/data/dc_reg_data.txt"
#define DC_FB_READ_FILE			"/data/dc_fb_data.argb"
#define DC_REG_WRITE_RECORD		"/data/dc_reg_w_record.txt"

/*dp*/
#define GB_DBG_DP_READ			0x01
#define GB_DBG_DP_WRITE			0x02
#define GB_DBG_DP_ONOFF			0x03
#define GB_DBG_DP_RATE			0x04
#define GB_DBG_DP_READ_RATE		0x05
#define GB_DBG_DP_READ_LANES		0x06

#define PHY_LANES_1			1
#define PHY_LANES_2			2
#define PHY_LANES_4			4
#define PHY_RATE_MAX			0x3


enum control_param {
	GB_DBG_CMD = 0,
	GB_DBG_PORT,
	GB_DBG_OFFSET,
	GB_DBG_VALUE,
	GB_DBG_MAX,
};

struct gb_debugfs_modeinfo {
	int vdisplay;
	int hdisplay;
	unsigned int pitch;
};
struct gb_debugfs_u32 {
	u32 value;
	u32 fb_offset;
	u32 crtc;
};
struct gb_debugfs_info {
    /* for debugfs */
	struct dentry *dentry_root;
	struct dentry *dentry_file_dc;
	struct dentry *dentry_file_dp;
	struct gb_debugfs_modeinfo *modeinfo;
	u32  r_val_dc;
	u32  r_val_dp;
};
int gb02_debugfs_init(struct gbdc_device *gb_dev);
void gb02_debugfs_fini(struct gbdc_device *gb_dev);
int gb02_debugfs_init_test(struct drm_minor *minor);

#endif
