/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __PCIE_RESIZEBAR_H
#define __PCIE_RESIZEBAR_H

/* Resizable BARs */
#define  GB_PCI_REBAR_CAP		4	/* capability register */
#define  GB_PCI_REBAR_CAP_SIZES		0x00FFFFF0  /* supported BAR sizes */
#define  GB_PCI_REBAR_CTRL		8	/* control register */
#define  GB_PCI_REBAR_CTRL_BAR_IDX		0x00000007  /* BAR index */
#define  GB_PCI_REBAR_CTRL_NBAR_MASK	0x000000E0  /* # of resizable BARs */
#define  GB_PCI_REBAR_CTRL_NBAR_SHIFT	5	    /* shift for # of BARs */
#define  GB_PCI_REBAR_CTRL_BAR_SIZE	0x00001F00  /* BAR size */
#define  GB_PCI_REBAR_CTRL_BAR_SHIFT	8	    /* shift for BAR size */

#if LINUX_VERSION_CODE < KERNEL_VERSION(4, 19, 0)
struct gb_pci_dev_resource {
	struct list_head list;
	struct resource *res;
	struct pci_dev *dev;
	resource_size_t start;
	resource_size_t end;      
	resource_size_t add_size;
	resource_size_t min_align;
	unsigned long flags;
};
void gb_pci_restore_rebar_state(struct pci_dev *pdev);
#endif

void gb_resize_pcie_bar2(struct pci_dev *pdev);
#endif