/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
#ifndef	__GB_GPUINFO_H__
#define	__GB_GPUINFO_H__
#define	MAX_INFO_LEN	128
#define	PCIE_BANDWIDTH	2
#define	VPU_TIME_COUNT	32

#define	LPDDR4_4266MHZ	11072962
#define	LPDDR4_3733MHZ	5704253
#define	LPDDR4_3200MHZ	80905

//#define FULL_GPUINFO

struct vpu_perf_time {
	struct gb_file_priv *filp;
	int frame_num;
	long start_time;
	long vpu_ave_time;
	long resv_start_time;
	long resv_time;
	long resv_free_ave_time;
	bool stop_flag;
};

struct gpu_info {
	char devmodel[MAX_INFO_LEN];
	char devname[MAX_INFO_LEN];
	char product[MAX_INFO_LEN];
	unsigned long long vram;
	int  clk;
	int	 bitwidth;
	int	 bandwidth;
	char driver_info[MAX_INFO_LEN];
	int	 vender_id;
	int	 device_id;
	char bus_info[MAX_INFO_LEN];
	unsigned int board_type ;
	unsigned long vpu_used;
	unsigned long vpu_total;
	unsigned long gpu_used;
	unsigned long gpu_total;
	int temp;
	struct vpu_perf_time vpu_time[VPU_TIME_COUNT];
};

struct gpu_info  *get_gbinfo_handle(void);

int gb_create_gpuinfo(struct gpu_info *gbinfo);

void gb_remove_gpuinfo(void);
int gb_gpu_sysfs_init(struct gb_device *gb_dev);
void gb_gpu_sysfs_fini(struct gb_device *gb_dev);
#endif
