/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _GB_UK_H_
#define _GB_UK_H_

#include <uapi/drm/drm.h>

#if defined(__cplusplus)
extern "C" {
#endif

#define GENBU01_PCI_VENDOR_ID           0x16c3
#define GENBU01_PCI_DEVICE_ID           0xabcd
#define GENBU_FPGA_PCI_VENDOR_ID	0x10ee
#define GENBU_FPGA_PCI_DEVICE_ID	0x8018

#define GENBU02_PCI_VENDOR_ID           0x8510
#define GENBU02_PCI_DEVICE_ID           0x0201

#define DRM_GB_SUBMIT			0x00
#define DRM_GB_WAIT_BO			0x01
#define DRM_GB_CREATE_BO		0x02
#define DRM_GB_MMAP_BO			0x03
#define DRM_GB_GET_PARAM		0x04
#define DRM_GB_GET_BO_OFFSET		0x05
#define DRM_GB_GET_BO_ADDR_MAPPING	0x06

#define DRM_GB_VPU_VCMD_OPEN            0x07
#define DRM_GB_VPU_REG_OPS              0x08
#define DRM_GB_VPU_VCMDBUF_RESERVE      0x09
#define DRM_GB_VPU_CMD_BUF_FREE         0x0a

#define DRM_GB_DMA_TRANS_TO_FB          0x0b
#define DRM_GB_DMA_TRANS_TO_RAM         0x0c
#define DRM_GB_V2VDMA_TRANS             0x0d
#define DRM_GB_HDMA_OFFSET_TRANS        0x0e

#define DRM_GB_GET_FB                   0x20
#define DRM_GB_GET_FULLSCREEN           0x21

#define DRM_GB_CREATE_FB                0x23
#define DRM_GB_SWITCH_FB                0x24

#define DRM_GB_GET_GPU_INFO             0x25

#define DRM_GB_SET_RENDER_SIZE          0x30

#define DRM_GB_GET_BO_VADDR	        	0x31
#define DRM_GB_SET_SCHED_TIME_MS		0x32
#define DRM_GB_VPU_VCMD_CLOSE	        0x33

#define DRM_GB_INFINITY_ATOMIC	        0x34

#define DRM_IOCTL_GB_SUBMIT \
	DRM_IOW(DRM_COMMAND_BASE + DRM_GB_SUBMIT, struct drm_gb_submit)
#define DRM_IOCTL_GB_WAIT_BO \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_WAIT_BO, struct drm_gb_wait_bo)
#define DRM_IOCTL_GB_CREATE_BO \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_CREATE_BO, struct drm_gb_create_bo)
#define DRM_IOCTL_GB_MMAP_BO \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_MMAP_BO, struct drm_gb_mmap_bo)
#define DRM_IOCTL_GB_GET_PARAM \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_GET_PARAM, struct drm_gb_get_param)
#define DRM_IOCTL_GB_GET_BO_OFFSET \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_GET_BO_OFFSET, struct drm_gb_get_bo_offset)
#define DRM_IOCTL_GB_GET_BO_ADDR_MAPPING \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_GET_BO_ADDR_MAPPING, struct drm_gb_get_bo_cpu_va)
	
#define DRM_IOCTL_GB_VPU_VCMD_OPEN \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_VPU_VCMD_OPEN, struct drm_gb_vpu_work)
#define DRM_IOCTL_GB_VPU_VCMD_CLOSE \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_VPU_VCMD_CLOSE, struct drm_gb_vpu_work)

#define DRM_IOCTL_GB_VPU_REG_OPS \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_VPU_REG_OPS, struct drm_gb_vpu_cmd)
#define DRM_IOCTL_GB_VPU_VCMDBUF_RESERVE \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_VPU_VCMDBUF_RESERVE, struct drm_gb_cmdbuf_resv)
#define DRM_IOCTL_GB_VPU_CMD_BUF_FREE \
		DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_VPU_CMD_BUF_FREE, struct drm_gb_cmdbuf_resv)

#define DRM_IOCTL_GB_DMA_TRANS_TO_FB \
        DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_DMA_TRANS_TO_FB, struct genbu_dma_trans_to_fb)
#define DRM_IOCTL_GB_DMA_TRANS_TO_RAM \
        DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_DMA_TRANS_TO_RAM, struct genbu_dma_trans_to_ram)
#define DRM_IOCTL_GB_V2VDMA_TRANS \
        DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_V2VDMA_TRANS, struct gbdc_genbu_v2vdma_trans)  
#define DRM_IOCTL_GB_HDMA_OFFSET_TRANS \
        DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_HDMA_OFFSET_TRANS, struct genbu_hdma_offset_trans)

#define DRM_IOCTL_GB_GET_FB \
        DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_GET_FB, struct genbu_get_fb_info)

#define DRM_IOCTL_GB_GET_FULLSCREEN \
        DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_GET_FULLSCREEN, struct genbu_get_fullscreen_info)

#define DRM_IOCTL_GB_CREATE_FB \
        DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_CREATE_FB, struct drm_gb_create_fb)

#define DRM_IOCTL_GB_SWITCH_FB \
        DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_SWITCH_FB, struct genbu_switch_fb)  

#define DRM_IOCTL_GB_GET_GPU_INFO \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_GET_GPU_INFO, struct gpu_info)

#define DRM_IOCTL_GB_SET_RENDER_SIZE \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_SET_RENDER_SIZE, struct genbu_set_render_size)

#define DRM_IOCTL_GB_GET_BO_VADDR \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_GET_BO_VADDR, struct drm_gb_get_bo_vaddr)
#define DRM_IOCTL_GB_SET_SCHED_TIME_MS \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_SET_SCHED_TIME_MS, struct genbu_set_sched_time)

#define DRM_IOCTL_GB_INFINITY_ATOMIC \
	DRM_IOWR(DRM_COMMAND_BASE + DRM_GB_INFINITY_ATOMIC, struct drm_mode_atomic)

/* Use 'k' as magic number */
#define GBDEC_IOC_MAGIC  'k'

#define GBDEC_PP_INSTANCE       _IO(GBDEC_IOC_MAGIC, 1)
#define GBDEC_HW_PERFORMANCE    _IO(GBODEC_IOC_MAGIC, 2)
#define GBDEC_IOCGHWOFFSET _IOR(GBDEC_IOC_MAGIC, 3, unsigned long *)
#define GBDEC_IOCGHWIOSIZE\
		_IOR(GBDEC_IOC_MAGIC, 4, struct regsize_desc *)

#define GBDEC_IOC_MC_OFFSETS\
	_IOR(GBDEC_IOC_MAGIC, 7, unsigned long *)
#define GBDEC_IOC_MC_CORES  _IOR(GBDEC_IOC_MAGIC, 8, unsigned int *)

#define GBDEC_IOCS_DEC_PUSH_REG\
	_IOW(GBDEC_IOC_MAGIC, 9, struct core_desc *)
#define GBDEC_IOCS_PP_PUSH_REG\
	_IOW(GBDEC_IOC_MAGIC, 10, struct core_desc *)

#define GBDEC_IOCH_DEC_RESERVE   _IO(GBDEC_IOC_MAGIC, 11)
#define GBDEC_IOCT_DEC_RELEASE   _IO(GBDEC_IOC_MAGIC, 12)
#define GBDEC_IOCQ_PP_RESERVE    _IO(GBDEC_IOC_MAGIC, 13)
#define GBDEC_IOCT_PP_RELEASE    _IO(GBDEC_IOC_MAGIC, 14)


#define GBDEC_IOCG_CORE_WAIT \
		_IOR(GBDEC_IOC_MAGIC, 19, int *)
#define GBDEC_IOX_ASIC_ID \
		_IOWR(GBDEC_IOC_MAGIC, 20, struct core_param *)
#define GBDEC_IOCG_CORE_ID \
		_IOR(GBDEC_IOC_MAGIC, 21, unsigned long)


#define GBDEC_IOCS_DEC_WRITE_REG \
	_IOW(GBDEC_IOC_MAGIC, 22, struct core_desc *)
#define GBDEC_IOCS_DEC_READ_REG \
	_IOWR(GBDEC_IOC_MAGIC, 23, struct core_desc *)
#define GBDEC_IOX_ASIC_BUILD_ID \
	_IOWR(GBDEC_IOC_MAGIC, 24, u32 *)
#define GBDEC_IOX_SUBSYS \
	_IOWR(GBDEC_IOC_MAGIC, 25, struct subsys_desc *)

#define GBDEC_DEBUG_STATUS   _IO(GBDEC_IOC_MAGIC, 29)

#define GBDEC_IOCS_DEC_WRITE_APBFILTER_REG \
	_IOW(GBDEC_IOC_MAGIC, 30, struct core_desc *)

#define GBDEC_IOC_AXIFE_CONFIG \
	_IOR(GBDEC_IOC_MAGIC, 32, struct axife_cfg *)

#define GBDEC_IOCS_DEC_PULL_REG \
	_IOWR(GBDEC_IOC_MAGIC, 17, struct core_desc *)
#define GBDEC_IOCS_PP_PULL_REG \
	_IOWR(GBDEC_IOC_MAGIC, 18, struct core_desc *)


#define GBDEC_IOC_MAXNR 32
#define GB_SD_REQ_FS (1 << 0)

#define GPU_DOMAIN_FLAG (1 << 0)
#define DC_DOMAIN_FLAG  (1 << 1)
#define VPU_DOMAIN_FLAG (1 << 2)

/*nomal vram=0; vcmd buff = 1; vcmd status = 2; */
enum gbdec_bo_flag {
	DEC_BO_NORMAL,
	DEC_BO_CMD_BUF,
	DEC_BO_CMD_STATUS,
	DEC_BO_CMD_REG
};

struct drm_gb_submit {
	__u64 sc;

	__u64 in_syncs;
	__u32 in_sync_count;

	__u32 out_sync;

	__u64 bo_handles;
	__u32 bo_handle_count;

	__u32 slot_req;

};

struct drm_gb_wait_bo {
	__u32 handle;
	__u32 pad;
	__s64 timeout_ns; /* absolute */
};

#define GB_BO_NOEXEC    (1<<0)
#define GB_BO_HEAP      (1<<1)
#define GB_BO_FB        (1<<2)
#define GB_BO_LOW_VA    (1<<3)
#define GB_BO_GROWABLE_MAP (1<<6)

#define GB_BO_INPUT     (1<<8)
#define GB_BO_OUTPP     (1<<9)
#define GB_BO_OUT       (1<<10)
#define GB_BO_CMDBUF    (1<<11)
#define GB_BO_CABAC     (1<<12)
#define GB_BO_TILE      (1<<13)
#define GB_BO_NOCLEAR   (1<<30)

#define GB_VBO_MODIFY_FLAG (GB_BO_OUT | GB_BO_OUTPP)
#define GB_VBO_NSAVE_FLAG (GB_BO_INPUT | GB_VBO_MODIFY_FLAG)
#define GB_VBO_SAVE_FLAG (GB_BO_CMDBUF | GB_BO_CABAC | GB_BO_TILE)
#define GB_VBO_NMMAP_FLAG (GB_BO_INPUT | GB_BO_OUT | GB_VBO_SAVE_FLAG)
#define GB_VBO_FLAG (GB_VBO_NSAVE_FLAG | GB_VBO_SAVE_FLAG)

#define GB_VALID_FLAG (GB_BO_NOEXEC | GB_BO_HEAP | GB_BO_FB | GB_BO_LOW_VA | GB_BO_GROWABLE_MAP | GB_VBO_FLAG | GB_BO_NOCLEAR)

#define	GB_DEC_BO_CMD_BUF	11
#define	GB_DEC1_BO_CMD_BUF	12
#define	GB_ENC_BO_CMD_BUF	21

enum ip_type {
	GB_IP_DEC = 1,
	GB_IP_ENC,
	GB_IP_DEC1,
};

enum vpu_module {
	VC8000E = 0,
	VC8000D = 2,
	JPEGD = 4,
};
struct drm_gb_cmdbuf_resv
{
/*input ;executing_time=encoded_image_size*(rdoLevel+data1)*(rdoq+1);*/
	__u64 executing_time;
/*input input vc8000e=0,IM=1,vc8000d=2, jpege=3, jpegd=4*/
	__u16 module_type;
/*input, reserve is not used; link and run is input.*/
	__u16 cmdbuf_size;
/*input,normal=0, high/live=1*/
	__u16 priority;
/*output, it is unique in driver.*/
	__u16 cmdbuf_id;
/*just used for polling.*/
	__u16 core_id;
	__u32 handle_count;
	__u64 handles;
	__u32 cmdbuf_offset;
	__u32 status_offset;
};


struct drm_gb_create_bo {
	__u32 size;
	__u32 flags;

	__u32 handle;
	__u32 domain;

	/*physical addr for vpu*/
	__u64 offset_va;
	__u64 offset_pa;

};
struct drm_gb_create_fb {
	struct drm_gb_create_bo bo;
	int fb_type;
};

struct gb_vpu_reserve {
	__u32 ip_type;
/*nomal vram=1; vcmd buff = 2; vcmd status = 3;*/
	__u32 flags;
	__u64 offset;
};

struct drm_gb_ip {
/*dec=1; enc = 2;*/
	__u32 ip_type;

	__u32 handle;
};

struct drm_gb_vpu_cmd {
/*dec=1; enc = 2;*/
	__u32 ip_type;
	__u32 cmd;
	void  *priv;

	__u32 handle;
};

struct drm_gb_mmap_bo {
	__u32 handle;
	__u32 flags;

	__u64 offset;
};

struct drm_gb_vpu_work {
        /*dec=1; enc = 2;*/
	__u32 ip_type;
	__u32 size;
	__u32 flags;

	__u32 handle;
	__u32 domain;

	/*gpu virtual addr*/
	__u64 offset_va;
	/*gpu physical addr*/
	__u64 offset_pa;
};

enum drm_gb_param {
	DRM_GB_PARAM_GPU_PROD_ID,
	DRM_GB_PARAM_GPU_REVISION,
	DRM_GB_PARAM_SHADER_PRESENT,
	DRM_GB_PARAM_TILER_PRESENT,
	DRM_GB_PARAM_L2_PRESENT,
	DRM_GB_PARAM_STACK_PRESENT,
	DRM_GB_PARAM_AS_PRESENT,
	DRM_GB_PARAM_SS_PRESENT,
	DRM_GB_PARAM_L2_FEATURES,
	DRM_GB_PARAM_CORE_FEATURES,
	DRM_GB_PARAM_TILER_FEATURES,
	DRM_GB_PARAM_MEM_FEATURES,
	DRM_GB_PARAM_MMU_FEATURES,
	DRM_GB_PARAM_THREAD_FEATURES,
	DRM_GB_PARAM_MAX_THREADS,
	DRM_GB_PARAM_THREAD_MAX_WORKGROUP_SZ,
	DRM_GB_PARAM_THREAD_MAX_BARRIER_SZ,
	DRM_GB_PARAM_COHERENCY_FEATURES,
	DRM_GB_PARAM_TEXTURE_FEATURES0,
	DRM_GB_PARAM_TEXTURE_FEATURES1,
	DRM_GB_PARAM_TEXTURE_FEATURES2,
	DRM_GB_PARAM_TEXTURE_FEATURES3,
	DRM_GB_PARAM_SS_FEATURES0,
	DRM_GB_PARAM_SS_FEATURES1,
	DRM_GB_PARAM_SS_FEATURES2,
	DRM_GB_PARAM_SS_FEATURES3,
	DRM_GB_PARAM_SS_FEATURES4,
	DRM_GB_PARAM_SS_FEATURES5,
	DRM_GB_PARAM_SS_FEATURES6,
	DRM_GB_PARAM_SS_FEATURES7,
	DRM_GB_PARAM_SS_FEATURES8,
	DRM_GB_PARAM_SS_FEATURES9,
	DRM_GB_PARAM_SS_FEATURES10,
	DRM_GB_PARAM_SS_FEATURES11,
	DRM_GB_PARAM_SS_FEATURES12,
	DRM_GB_PARAM_SS_FEATURES13,
	DRM_GB_PARAM_SS_FEATURES14,
	DRM_GB_PARAM_SS_FEATURES15,
	DRM_GB_PARAM_NR_CORE_GROUPS,
	DRM_GB_PARAM_GROW_HEAP_MEMORY,
	DRM_GB_PARAM_VPU_BO_SAVE_FLAG,
};

struct drm_gb_get_param {
	__u32 param;
	__u32 pad;
	__u64 value;
};

struct drm_gb_get_bo_offset {
	__u32 handle;
	__u32 pad;
	__u64 offset;
};

struct drm_gb_get_bo_vaddr {
	__u32 handle;
	__u32 pad;
	__u64 vaddr;
};

struct drm_gb_get_bo_cpu_va {
	__u64 gpu_va;
#ifdef GB_KMD_DBG
	__u64 gpu_pa;
#endif
	__u64 cpu_va;
	__u64 cpu_va_start;
	__u64 cpu_va_end;
};

enum gb_dma_data_direction {
	/* RAM TO VRAM */
	GB_DMA_TO_DEVICE = 0,
	/* VRAM TO RAM */
	GB_DMA_FROM_DEVICE = 1,
	GB_DMA_NONE,
};

struct genbu_dma_trans_to_fb {
	/* fb handle, user set */
	__u32 handle;
	/* window width of which for dma trans, user set */
	__u32 width;
	/* window height of which for dma trans, user set */
	__u32 height;
	/* current plane width, ex:1920*1080p is 1920, user set */
	__u32 plane_width;
	/* number of ll entry, user don't care */
	__u32 num_dma_entry;
	/* ram va, user set, must be 4K align */
	__u64 cpu_va;
	/* vram va base, user set */
	__u64 gpu_va_base;
	/* vram va, user set */
	__u64 gpu_va;
	/* ll table's addr for dma trans, user don't care */
	__u64 ll_table_addr;
	/* dma dir, user set */
	enum gb_dma_data_direction dma_direction;
};

struct genbu_dma_trans_to_ram {
	/* fb handle, user set */
	__u32 handle;
	/* ram va, user set, must be 4K align */
	__u64 cpu_va;
	/* dma trans size */
	__u64 size;
	/* dma dir, user set */
	enum gb_dma_data_direction dma_direction;
};

struct genbu_hdma_offset_trans {
	/* fb handle, user set */
	__u32 handle;
	/* ram va, user set, must be 4K align */
	__u64 cpu_va;
	/* dma trans size */
	__u64 size;
	/* dma trans offset */
	__u64 offset;
	/* dma dir, user set */
	enum gb_dma_data_direction dma_direction;
};

struct gbdc_genbu_v2vdma_trans {
	__u32 src_handle;
	__u32 dst_handle;
	__u64 src_offset;
	__u64 dst_offset;
	size_t size;
};

struct genbu_get_fb_info {
	__u64 height;
	__u64 width;
	__u64 size;
};

struct genbu_get_fullscreen_info {
	int flag;
	__u64 gpu_va;
};

struct genbu_switch_fb {
	int switch_fb;
};

struct genbu_set_render_size {
	__u32 size;
};

struct genbu_set_sched_time {
	__u32 timems;
};

#if defined(__cplusplus)
}
#endif

#endif /* _GB_UK_H_ */
