/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __GB_GPU_H__
#define __GB_GPU_H__

struct gb_device;

int gb_gpu_init(struct gb_device *gbdev);
void gb_gpu_release(struct gb_device *gbdev);

u32 gb_gpu_get_latest_flush_id(struct gb_device *gbdev);

void gb_gpu_disable_irq(struct gb_device *gbdev);
int gb_gpu_soft_reset(struct gb_device *gbdev);
void gb_gpu_L2_cache_power_on(void);
void gb_gpu_L2_cache_power_off(void);
void gb_gpu_power_on(struct gb_device *gbdev);
void gb_gpu_power_off(struct gb_device *gbdev);

#endif
