
/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __GB_IRQ_H__
#define __GB_IRQ_H__

#include <linux/bitfield.h>
#include <linux/bitmap.h>
#include <linux/delay.h>
#include <linux/dma-mapping.h>
#include <linux/interrupt.h>
#include <linux/io.h>
#include <linux/iopoll.h>
#include <linux/pci.h>

irqreturn_t gb_gpu_irq_func(int irq, void *data);
irqreturn_t gb_gpu_irq_handler(struct gb_device *gbdev, u32 status);

irqreturn_t gb_stage_irq_handler_thread(int irq, void *data);
irqreturn_t gb_stage_mulirq_handler(int irq, void *data);
irqreturn_t gb_stage_compirq_handler(int irq, void *data);
void gb_stage_handle_irqs(struct gb_device *gbdev);

irqreturn_t gb_mmu_irq_handler_thread(int irq, void *data);
irqreturn_t gb_mmu_irq_handler(int irq, void *data);

int gb_gpu_irq_init(struct gb_device *gbdev);
int gb_irq_release(struct gb_device *gbdev);
void gb_sync_irq(struct gb_device *gbdev);
irqreturn_t gb_common_irq_handler(int irq, void *data);

void gb_irq_apply_handle(struct gb_device *gbdev);
#endif
