/* SPDX-License-Identifier: GPL-3.0-or-later */
/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
#ifndef __GB_IP_OFFSET_H__
#define __GB_IP_OFFSET_H__
#include "common/gb_common.h"

#ifdef PALADING_MODE
#define VPU_DEC0_OFFSET 0x1400000
#define VPU_DEC1_OFFSET 0x1800000
#define VPU_ENC_OFFSET  0x1C00000
#endif

#ifdef FPGA_MODE
#define VPU_DEC0_OFFSET 0x81400000
#define VPU_DEC1_OFFSET 0x81800000
#define VPU_ENC_OFFSET  0x81C00000
#endif

#define VPU_AUDIO_OFFSET 0x80400000
#define VPU_AUDIO_INTERAL 0x800
#define VPU_AUDIO_COUNT  6


struct vpu_offset_base {
	u32	dec0_offset_base;
	u32 dec1_offset_base;
	u32 enc_offset_base;
};

struct audio_offset_base {
	u32	audio_offset_base;
	u32 audio_interval;
	u32 audio_num;
};

struct dcdp_offset_base {

};

struct gpu_offset_base {
	u32	gpu_offset_base;
	u32 gpu_interval;
	u32 gpu_num;
};



struct gbip_offset_base {
	struct vpu_offset_base	vpu_offset;
	struct audio_offset_base audio_offset;
	struct dcdp_offset_base dcdp_offset;
	struct gpu_offset_base gpu_offset;
};


#endif
