#ifndef GB_PAGE_ALLOCS_H_
#define GB_PAGE_ALLOC_H_

int gb_alloc_pages(struct gb_device *gbdev, size_t nr_pages, phys_addr_t *pages);
void gb_free_pages(struct gb_page *gb_page, struct gb_device *gbdev);

struct gb_page *gb_alloc_mmu_page(struct gb_device *gbdev);
void gb_free_mmu_page(struct gb_page *gb_page, struct gb_device *gbdev);

int gb_vram_alloc_pages(struct gb_device *gbdev, size_t nr_pages, phys_addr_t *pages);
void gb_vram_free_pages(struct gb_device *gbdev, size_t nr_pages, phys_addr_t *pages);

struct gb_page *gb_phys_to_page(struct gb_device *gbdev, phys_addr_t phys);
phys_addr_t gb_page_to_phys(struct gb_page *p);

u64 *gb_kmap(struct gb_page *p);

#endif
