/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <linux/module.h>
#ifndef		__GBDC_DEVICE_H__
#define		__GBDC_DEVICE_H__

extern struct gb_plane_cap gbPlaneCap[];

int gb_base_init(int card_type, struct gbdc_pcie_info *pcie_info,
	struct gb_asic_dev_info *pcie_res,
	struct gb_ip_base_offset *gbip_reg_offset,
	struct gb_crtc_offset *ctc_offset);
void gb_kms_res_init(struct gb_kms_info *kms_info, struct gb_kms_res *kms_res);
void gb_pm_init(struct gb_pm_info *gb_pm);
void gbdev_init(struct gbdc_device *gb_dev,
		    struct drm_device *drm_dev,
		    struct pci_dev *pdev, int card_type);
void gbdev_uninit(struct gbdc_device *gb_dev);
int gbdev_info_init(struct gbdc_device *gb_dev);
struct gbdc_device *gb_get_gbdc_device(void *dev_private);
struct gbdc_device *gb_get_gb_device(void *dev_private);
static inline bool gbdc_check_use_infinity(struct gb_kms_info *kms_info)
{
	return kms_info->infinity;
}



#endif
