/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <linux/module.h>
#ifndef	__GBDC_OPS_H__
#define	__GBDC_OPS_H__


#define	GB_COEFFTAB_NUM_COEFFS 64

enum overlay_attrbute {
	VOERLAY_ADDR,
	OVERLAY_RESOLUTION
};

struct gbdc_base_info {
	void __iomem *dc_base;
	void __iomem *de_base;
};

struct gbdc_overlay_info {
	int	w;
	int h;
	int x;
	int y;
	u64 yaddr;
	u64 cbaddr;
	int format;	//nv12,p010
	int ol_id;	//0,1
	int	attr;	//VOERLAY_ADDR
	int layer_id; //0,2
};

int config_file_strkv(char *key, char *val, size_t len);
int gb_config_overlay(void __iomem *dc_base, void __iomem *de_base,
	struct gbdc_overlay_info *olinfo);
int gb_close_overlay(u16 base, void __iomem *dc_base, void __iomem *de_base);
int gb_set_base(void __iomem *dc_base, void __iomem *de_base);
int gb_get_base(void __iomem **dc_base, void __iomem **de_base);
#ifdef GB_ALLSCREEN
#define MAX_CRTC_ID 6
int gbdc_check_first_dc_num(void);
int gbdc_check_all_enable_dc_num(int *crtc_id_list);
int gbdc_check_expend_plane(int *crtc_id_list, int crtc_num,
	struct gb_config_full_screen *crtc_info);

#endif
#endif
