/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef	__GB_PCIE_MAP_H__
#define	__GB_PCIE_MAP_H__

#include <linux/module.h>
#include "common/gb_pcie_info.h"

#define	BAR_LEN		3
#define	BAR_NUM		6
#define	FPGA_PLL_STEP	0x1000
struct gb_asic_info {
	enum genbu_asic_type gb_type;
	unsigned long vram_size;
	int pci_bar_cnt;
	int gpu_reg_bar_id;
	int dc_reg_bar_id;
	int ddr_bar_id;
	int pll_bar_id;
};
struct gbdc_config_regmap{

	//const u32		gpu_conf_base;
	void __iomem 	*de_base;
	/* address offset of the SE registers bank */
	void __iomem 	*se_base;
	/* address offset of the DC registers bank */
	void __iomem 	*dc_base;

};

struct gb_reg_ops {
	int	(*mm_read)(void *baseAddr, u32 offset);
	int (*mm_write)(void *baseAddr, u32 offset, u32 value);
	int (*io_read)(void *baseAddr, u32 offset);
	int (*io_write)(void *baseAddr, u32 offset, u32 value);
	int (*set_bits)(void *baseAddr, u32 offset, u32 mask);
	int (*clear_bits)(void *baseAddr, u32 offset, u32 mask);
};

struct gb_common_ops {
	int (*get_version)(void __iomem *baseAddr, void *gb_version);
};
struct gbip_config_regmap{
	void __iomem	*pcie_config_base;
	void __iomem 	*dpll_config_base;
	void __iomem 	*pll_config_base;
	void __iomem 	*hdmi_config_base;
	void __iomem 	*hdmi_debug_base;
	void __iomem 	*fpga_pll_base;
	int		fpga_pll_step;
};

struct gb_vram_info{
	void __iomem 	*fb_map;
	unsigned long 	fb_base;
	u64		fb_start_offset;
	u64 vram_size;
};


struct gbdc_pcie_info{
	//struct gbdc_device 				*gbDev;
//	void __iomem 					*regs;
	void __iomem 	*pci_mmio_bar[BAR_NUM];
	uintptr_t	start_bar[BAR_NUM];
	u64		len_bar[BAR_NUM];

	int		dc_num;
	int		dc_base_offset;
	struct gbdc_config_regmap 	*dc_config;
	struct gbip_config_regmap 	ip_config;
	struct gb_vram_info		vram_config;
	struct gb_asic_dev_info		asic_dinfo;
//	struct gb_reg_ops		*reg_ops;
	struct gb_common_ops		*gb_cops;
};
#endif
