/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <linux/delay.h>
#include <linux/version.h>
#include "gb_pcie_map.h"
#include "gbdc_fbdev.h"
#include "gpu/gb_gem.h"
#include "common/gb_bo.h"
#ifndef		__GBDC_MM_H__
#define		__GBDC_MM_H__

int gbdc_dumb_create(struct drm_file *file, struct drm_device *dev,
		     struct drm_mode_create_dumb *args);
int gbdc_dumb_mmap_offset(struct drm_file *file, struct drm_device *dev,
			  uint32_t handle, uint64_t * offset);
int gbdc_framebuffer_init(struct drm_device *dev,
			  struct gbdc_framebuffer *gfb,
			  const struct drm_mode_fb_cmd2 *mode_cmd,
			  struct drm_gem_object *obj);
int gbdc_drm_gem_fb_init_with_funcs(struct drm_device *dev,
				struct drm_file *filp,
				struct gbdc_framebuffer *gfb,
				const struct drm_mode_fb_cmd2 *mode_cmd);
int gbdc_gem_create(struct drm_device *dev, u32 size, bool iskernel,
		    struct drm_gem_object **obj);
#endif
