/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __GB_BACKLIGHT_H
#define __GB_BACKLIGHT_H

#include <linux/backlight.h>
#include "gpu/gb_device.h"

struct backlight_data {
	void __iomem *sysctl_iofunc_base;
	u32 last_brightness;
	struct dptx *dptx_info;
	struct backlight_device *bl;
	bool by_dptx;
};

#ifdef CONFIG_GB_BACKLIGHT
struct backlight_data *gb_get_backlight_data(int index);
int gb_register_backlight(struct gb_pcie_info *pcie_info, struct dptx *dptx_info);
void gb_unregister_backlight(struct dptx *dptx_info);
#else
static inline struct backlight_data *gb_get_backlight_data(int index){return NULL;}
static inline int gb_register_backlight(struct gb_pcie_info *pcie_info, struct dptx *dptx_info){return -1;}
static inline void gb_unregister_backlight(struct dptx *dptx_info){return;}
#endif
#endif
