/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __FAN_GB02_MCU_H
#define __FAN_GB02_MCU_H
#include "gb-peripherals-common.h"

#define GB02_FAN_DEV_NAME "gb02-fan"

#ifdef CONFIG_MCU_FAN
int gb02_fan_drv_init(struct gb_device *gb_dev, struct gb02_mcu_peripherals_info *peri_info);
void gb02_fan_drv_exit(struct gb02_mcu_peripherals_info *peri_info);
int gb02_fan_drv_suspend(struct gb02_mcu_peripherals_info *peri_info);
int gb02_fan_drv_resume(struct gb02_mcu_peripherals_info *peri_info);
#else
static inline int gb02_fan_drv_init(struct gb_device *gb_dev, struct gb02_mcu_peripherals_info *peri_info)
{
	return 0;
}
static inline void gb02_fan_drv_exit(struct gb02_mcu_peripherals_info *peri_info)
{
	return;
}
static inline int gb02_fan_drv_suspend(struct gb02_mcu_peripherals_info *peri_info)
{
	return 0;
}
static inline int gb02_fan_drv_resume(struct gb02_mcu_peripherals_info *peri_info)
{
	return 0;
}
#endif
#endif /* __FAN_GB02_MCU_H */
