/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __FREQ_GB02_MCU_H
#define __FREQ_GB02_MCU_H
#include <linux/notifier.h>
#include "gb-peripherals-common.h"

#define TEMP_NORMAL_EVENT 0
#define TEMP_HOT_EVENT 1
#define JOB_FULL_EVENT 2

extern struct blocking_notifier_head limit_freq_notifier_chain;

#ifdef CONFIG_MCU_FREQ
u32 get_cur_gpu_freq(void);
int gb02_freq_drv_init(struct gb_device *gb_dev, struct gb02_mcu_peripherals_info *peri_info);
void gb02_freq_drv_exit(struct gb02_mcu_peripherals_info *peri_info);
void gb_devfreq_record_transition(struct gb_device *gb_dev, int slot);
#else
static inline u32 get_cur_gpu_freq(void)
{
	return 0;
}
static inline int gb02_freq_drv_init(struct gb_device *gb_dev, struct gb02_mcu_peripherals_info *peri_info)
{
	return 0;
}
static inline void gb02_freq_drv_exit(struct gb02_mcu_peripherals_info *peri_info)
{
	return;
}
static inline void gb_devfreq_record_transition(struct gb_device *gb_dev, int slot)
{
	return;
}
#endif
#endif /* __FREQ_GB02_MCU_H */
