/* SPDX-License-Identifier: GPL-2.0-only */
#ifndef __TMP102_H
#define __TMP102_H
#include "i2c-gb02-mcu.h"
#define	TMP102_TEMP_REG			0x00
#define	TMP102_CONF_REG			0x01
/* note: these bit definitions are byte swapped */
#define		TMP102_CONF_SD		0x0100
#define		TMP102_CONF_TM		0x0200
#define		TMP102_CONF_POL		0x0400
#define		TMP102_CONF_F0		0x0800
#define		TMP102_CONF_F1		0x1000
#define		TMP102_CONF_R0		0x2000
#define		TMP102_CONF_R1		0x4000
#define		TMP102_CONF_OS		0x8000
#define		TMP102_CONF_EM		0x0010
#define		TMP102_CONF_AL		0x0020
#define		TMP102_CONF_CR0		0x0040
#define		TMP102_CONF_CR1		0x0080
#define	TMP102_TLOW_REG			0x02
#define	TMP102_THIGH_REG		0x03

#define TMP102_CONFREG_MASK	(TMP102_CONF_SD | TMP102_CONF_TM | \
				 TMP102_CONF_POL | TMP102_CONF_F0 | \
				 TMP102_CONF_F1 | TMP102_CONF_OS | \
				 TMP102_CONF_EM | TMP102_CONF_AL | \
				 TMP102_CONF_CR0 | TMP102_CONF_CR1)

#define TMP102_CONFIG_CLEAR	(TMP102_CONF_SD | TMP102_CONF_OS | \
				 TMP102_CONF_CR0)
#define TMP102_CONFIG_SET	(TMP102_CONF_TM | TMP102_CONF_EM | \
				 TMP102_CONF_CR1)

#define CONVERSION_TIME_MS		35	/* in milli-seconds */

#define TMP102_WRITE_FRM_LEN 4
#define TMP102_READ_FRM_LEN 5
#define TMP102_ADDR  0x50
#define TMP102_BUS_ID  0
#define TMP102_DEVICE_NAME "tmp102"
struct tmp102 {
	struct regmap *regmap;
	u16 config_orig;
	unsigned long ready_time;
};

#ifdef CONFIG_MCU_I2C
int tmp102_device_init(struct gb02_mcu_i2c *gb02_i2c);
int tmp102_remove(struct gb02_mcu_i2c *gb02_i2c);
#else
static inline int tmp102_device_init(struct gb02_mcu_i2c *gb02_i2c)
{
	return 0;
}
static inline int tmp102_remove(struct gb02_mcu_i2c *gb02_i2c)
{
	return 0;
}
#endif
#endif
