/* SPDX-License-Identifier: GPL-3.0-or-later */
/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * jessy 20221019 Sietium
 */

#ifndef __VPU_DEC_H__
#define __VPU_DEC_H__
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/semaphore.h>
#include <linux/spinlock.h>
#include <linux/ioctl.h>
#include <linux/types.h>
#include <linux/fs.h>
/* standard error codes */
#include <linux/errno.h>
#include <linux/interrupt.h>
#include <linux/version.h>
#include <linux/vmalloc.h>


//#include "vpu_subsys.h"
#include "vpu/vpu_comm/vpu_comm.h"
#include "vpu/vpu_comm/vpu_vcmd_registers.h"

extern unsigned long multicorebase[HXDEC_MAX_CORES];
extern int irq[HXDEC_MAX_CORES];
extern unsigned int iosize[HXDEC_MAX_CORES];


void hw_axife_comm_handle(int i, int j,
		struct DEC_PRIVATE_DATA *dec_data);
void hw_vc8000d_comm_handle(int i, int j,
		struct DEC_PRIVATE_DATA *dec_data);
struct DEC_PRIVATE_DATA *get_dec_private_handle(void);
unsigned long *get_dec_multicorebase(void);
int *get_dec_irq(void);
unsigned int *get_dec_iosize(void);
long dec_ioctl(struct drm_file *filp,
	unsigned int cmd, void *arg);
void dec_cleanup(int total_vcmd_core_num);
void dec_private_data_init(struct DEC_PRIVATE_DATA *dec_data,
	struct gb_pci_bar *pci_bars, struct gb_asic_dev_info *dev_info,
	struct vpu_offset_base vpu_offset);
#endif
