/* SPDX-License-Identifier: GPL-3.0-or-later */
/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * jessy 20221019 Sietium
 */
#ifndef __VPU_VC8000E_VCMD_H__
#define __VPU_VC8000E_VCMD_H__
#include "common/gb_uk.h"
#include "vpu/vpu_comm/vpu_list.h"
#include "vpu/vpu_comm/vpu_vcmd_registers.h"
#include "vpu/vpu_comm/vpu_comm.h"
#include "vpu/vpu_comm/vpu_basetype.h"

/* VCMD CONFIGURATION BY CUSTOMER********/
//video encoder vcmd configuration
#define VCMD_ENC_IO_ADDR_0                      0x0
#define VCMD_ENC_IO_SIZE_0                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_ENC_INT_PIN_0                      -1
#define VCMD_ENC_MODULE_TYPE_0                  0
#define VCMD_ENC_MODULE_MAIN_ADDR_0             0x1000
#define VCMD_ENC_MODULE_DEC400_ADDR_0           0XFFFF
#define VCMD_ENC_MODULE_L2CACHE_ADDR_0          0XFFFF
#define VCMD_ENC_MODULE_MMU0_ADDR_0             0XFFFF
#define VCMD_ENC_MODULE_MMU1_ADDR_0             0XFFFF
#define VCMD_ENC_MODULE_AXIFE0_ADDR_0           0XFFFF
#define VCMD_ENC_MODULE_AXIFE1_ADDR_0           0XFFFF

#define VCMD_ENC_IO_ADDR_1                      0x91000
#define VCMD_ENC_IO_SIZE_1                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_ENC_INT_PIN_1                      -1
#define VCMD_ENC_MODULE_TYPE_1                  0
#define VCMD_ENC_MODULE_MAIN_ADDR_1             0x0000
#define VCMD_ENC_MODULE_DEC400_ADDR_1           0XFFFF
#define VCMD_ENC_MODULE_L2CACHE_ADDR_1          0XFFFF
#define VCMD_ENC_MODULE_MMU_ADDR_1              0XFFFF

#define VCMD_ENC_IO_ADDR_2                      0x92000
#define VCMD_ENC_IO_SIZE_2                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_ENC_INT_PIN_2                      -1
#define VCMD_ENC_MODULE_TYPE_2                  0
#define VCMD_ENC_MODULE_MAIN_ADDR_2             0x0000
#define VCMD_ENC_MODULE_DEC400_ADDR_2           0XFFFF
#define VCMD_ENC_MODULE_L2CACHE_ADDR_2          0XFFFF
#define VCMD_ENC_MODULE_MMU_ADDR_2              0XFFFF

#define VCMD_ENC_IO_ADDR_3                      0x93000
#define VCMD_ENC_IO_SIZE_3                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_ENC_INT_PIN_3                      -1
#define VCMD_ENC_MODULE_TYPE_3                  0
#define VCMD_ENC_MODULE_MAIN_ADDR_3             0x0000
#define VCMD_ENC_MODULE_DEC400_ADDR_3           0XFFFF
#define VCMD_ENC_MODULE_L2CACHE_ADDR_3          0XFFFF
#define VCMD_ENC_MODULE_MMU_ADDR_3              0XFFFF

/* video encoder cutree/IM  vcmd configuration */
#define VCMD_IM_IO_ADDR_0                      0x94000
#define VCMD_IM_IO_SIZE_0                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_IM_INT_PIN_0                      -1
#define VCMD_IM_MODULE_TYPE_0                  1
#define VCMD_IM_MODULE_MAIN_ADDR_0             0x1000
#define VCMD_IM_MODULE_DEC400_ADDR_0           0XFFFF
#define VCMD_IM_MODULE_L2CACHE_ADDR_0          0XFFFF
#define VCMD_IM_MODULE_MMU0_ADDR_0             0XFFFF
#define VCMD_IM_MODULE_MMU1_ADDR_0             0XFFFF
#define VCMD_IM_MODULE_AXIFE0_ADDR_0           0XFFFF
#define VCMD_IM_MODULE_AXIFE1_ADDR_0           0XFFFF

#define VCMD_IM_IO_ADDR_1                      0xa1000
#define VCMD_IM_IO_SIZE_1                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_IM_INT_PIN_1                      -1
#define VCMD_IM_MODULE_TYPE_1                  1
#define VCMD_IM_MODULE_MAIN_ADDR_1             0x0000
#define VCMD_IM_MODULE_DEC400_ADDR_1           0XFFFF
#define VCMD_IM_MODULE_L2CACHE_ADDR_1          0XFFFF
#define VCMD_IM_MODULE_MMU_ADDR_1              0XFFFF

#define VCMD_IM_IO_ADDR_2                      0xa2000
#define VCMD_IM_IO_SIZE_2                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_IM_INT_PIN_2                      -1
#define VCMD_IM_MODULE_TYPE_2                  1
#define VCMD_IM_MODULE_MAIN_ADDR_2             0x0000
#define VCMD_IM_MODULE_DEC400_ADDR_2           0XFFFF
#define VCMD_IM_MODULE_L2CACHE_ADDR_2          0XFFFF
#define VCMD_IM_MODULE_MMU_ADDR_2              0XFFFF

#define VCMD_IM_IO_ADDR_3                      0xa3000
#define VCMD_IM_IO_SIZE_3                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_IM_INT_PIN_3                      -1
#define VCMD_IM_MODULE_TYPE_3                  1
#define VCMD_IM_MODULE_MAIN_ADDR_3             0x0000
#define VCMD_IM_MODULE_DEC400_ADDR_3           0XFFFF
#define VCMD_IM_MODULE_L2CACHE_ADDR_3          0XFFFF
#define VCMD_IM_MODULE_MMU_ADDR_3              0XFFFF

//video decoder vcmd configuration

#if 0
#define VCMD_DEC_IO_ADDR_0                      0xb0000
#define VCMD_DEC_IO_SIZE_0                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_DEC_INT_PIN_0                      -1
#define VCMD_DEC_MODULE_TYPE_0                  2
#define VCMD_DEC_MODULE_MAIN_ADDR_0             0x0000
#define VCMD_DEC_MODULE_DEC400_ADDR_0           0XFFFF
#define VCMD_DEC_MODULE_L2CACHE_ADDR_0          0XFFFF
#define VCMD_DEC_MODULE_MMU_ADDR_0              0XFFFF

#define VCMD_DEC_IO_ADDR_1                      0xb1000
#define VCMD_DEC_IO_SIZE_1                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_DEC_INT_PIN_1                      -1
#define VCMD_DEC_MODULE_TYPE_1                  2
#define VCMD_DEC_MODULE_MAIN_ADDR_1             0x0000
#define VCMD_DEC_MODULE_DEC400_ADDR_1           0XFFFF
#define VCMD_DEC_MODULE_L2CACHE_ADDR_1          0XFFFF
#define VCMD_DEC_MODULE_MMU_ADDR_1              0XFFFF

#define VCMD_DEC_IO_ADDR_2                      0xb2000
#define VCMD_DEC_IO_SIZE_2                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_DEC_INT_PIN_2                      -1
#define VCMD_DEC_MODULE_TYPE_2                  2
#define VCMD_DEC_MODULE_MAIN_ADDR_2             0x0000
#define VCMD_DEC_MODULE_DEC400_ADDR_2           0XFFFF
#define VCMD_DEC_MODULE_L2CACHE_ADDR_2          0XFFFF
#define VCMD_DEC_MODULE_MMU_ADDR_2              0XFFFF

#define VCMD_DEC_IO_ADDR_3                      0xb3000
#define VCMD_DEC_IO_SIZE_3                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_DEC_INT_PIN_3                      -1
#define VCMD_DEC_MODULE_TYPE_3                  2
#define VCMD_DEC_MODULE_MAIN_ADDR_3             0x0000
#define VCMD_DEC_MODULE_DEC400_ADDR_3           0XFFFF
#define VCMD_DEC_MODULE_L2CACHE_ADDR_3          0XFFFF
#define VCMD_DEC_MODULE_MMU_ADDR_3              0XFFFF

//JPEG encoder vcmd configuration

#define VCMD_JPEGE_IO_ADDR_0                      0x90000
#define VCMD_JPEGE_IO_SIZE_0                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_JPEGE_INT_PIN_0                      -1
#define VCMD_JPEGE_MODULE_TYPE_0                  3
#define VCMD_JPEGE_MODULE_MAIN_ADDR_0             0x1000
#define VCMD_JPEGE_MODULE_DEC400_ADDR_0           0XFFFF //0X4000
#define VCMD_JPEGE_MODULE_L2CACHE_ADDR_0          0XFFFF
#define VCMD_JPEGE_MODULE_MMU0_ADDR_0             0XFFFF //0X2000
#define VCMD_JPEGE_MODULE_MMU1_ADDR_0             0XFFFF
#define VCMD_JPEGE_MODULE_AXIFE0_ADDR_0           0XFFFF //0X3000
#define VCMD_JPEGE_MODULE_AXIFE1_ADDR_0           0XFFFF

#define VCMD_JPEGE_IO_ADDR_1                      0xC1000
#define VCMD_JPEGE_IO_SIZE_1                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_JPEGE_INT_PIN_1                      -1
#define VCMD_JPEGE_MODULE_TYPE_1                  3
#define VCMD_JPEGE_MODULE_MAIN_ADDR_1             0x0000
#define VCMD_JPEGE_MODULE_DEC400_ADDR_1           0XFFFF
#define VCMD_JPEGE_MODULE_L2CACHE_ADDR_1          0XFFFF
#define VCMD_JPEGE_MODULE_MMU_ADDR_1              0XFFFF

#define VCMD_JPEGE_IO_ADDR_2                      0xC2000
#define VCMD_JPEGE_IO_SIZE_2                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_JPEGE_INT_PIN_2                      -1
#define VCMD_JPEGE_MODULE_TYPE_2                  3
#define VCMD_JPEGE_MODULE_MAIN_ADDR_2             0x0000
#define VCMD_JPEGE_MODULE_DEC400_ADDR_2           0XFFFF
#define VCMD_JPEGE_MODULE_L2CACHE_ADDR_2          0XFFFF
#define VCMD_JPEGE_MODULE_MMU_ADDR_2              0XFFFF

#define VCMD_JPEGE_IO_ADDR_3                      0xC3000
#define VCMD_JPEGE_IO_SIZE_3                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_JPEGE_INT_PIN_3                      -1
#define VCMD_JPEGE_MODULE_TYPE_3                  3
#define VCMD_JPEGE_MODULE_MAIN_ADDR_3             0x0000
#define VCMD_JPEGE_MODULE_DEC400_ADDR_3           0XFFFF
#define VCMD_JPEGE_MODULE_L2CACHE_ADDR_3          0XFFFF
#define VCMD_JPEGE_MODULE_MMU_ADDR_3              0XFFFF

//JPEG decoder vcmd configuration

#define VCMD_JPEGD_IO_ADDR_0                      0xD0000
#define VCMD_JPEGD_IO_SIZE_0                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_JPEGD_INT_PIN_0                      -1
#define VCMD_JPEGD_MODULE_TYPE_0                  4
#define VCMD_JPEGD_MODULE_MAIN_ADDR_0             0x0000
#define VCMD_JPEGD_MODULE_DEC400_ADDR_0           0XFFFF
#define VCMD_JPEGD_MODULE_L2CACHE_ADDR_0          0XFFFF
#define VCMD_JPEGD_MODULE_MMU_ADDR_0              0XFFFF

#define VCMD_JPEGD_IO_ADDR_1                      0xD1000
#define VCMD_JPEGD_IO_SIZE_1                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_JPEGD_INT_PIN_1                      -1
#define VCMD_JPEGD_MODULE_TYPE_1                  4
#define VCMD_JPEGD_MODULE_MAIN_ADDR_1             0x0000
#define VCMD_JPEGD_MODULE_DEC400_ADDR_1           0XFFFF
#define VCMD_JPEGD_MODULE_L2CACHE_ADDR_1          0XFFFF
#define VCMD_JPEGD_MODULE_MMU_ADDR_1              0XFFFF

#define VCMD_JPEGD_IO_ADDR_2                      0xD2000
#define VCMD_JPEGD_IO_SIZE_2                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_JPEGD_INT_PIN_2                      -1
#define VCMD_JPEGD_MODULE_TYPE_2                  4
#define VCMD_JPEGD_MODULE_MAIN_ADDR_2             0x0000
#define VCMD_JPEGD_MODULE_DEC400_ADDR_2           0XFFFF
#define VCMD_JPEGD_MODULE_L2CACHE_ADDR_2          0XFFFF
#define VCMD_JPEGD_MODULE_MMU_ADDR_2              0XFFFF

#define VCMD_JPEGD_IO_ADDR_3                      0xD3000
#define VCMD_JPEGD_IO_SIZE_3                      (ASIC_VCMD_SWREG_AMOUNT * 4)
#define VCMD_JPEGD_INT_PIN_3                      -1
#define VCMD_JPEGD_MODULE_TYPE_3                  4
#define VCMD_JPEGD_MODULE_MAIN_ADDR_3             0x0000
#define VCMD_JPEGD_MODULE_DEC400_ADDR_3           0XFFFF
#define VCMD_JPEGD_MODULE_L2CACHE_ADDR_3          0XFFFF
#define VCMD_JPEGD_MODULE_MMU_ADDR_3              0XFFFF
#endif
#define NETINT

/* Use 'k' as magic number */
#define HANTRO_IOC_MAGIC  'k'
#define HANTRO_IOC_MMU    'm'

/*
 * S means "Set" through a ptr,
 * T means "Tell" directly with the argument value
 * G means "Get": reply by setting through a pointer
 * Q means "Query": response is on the return value
 * X means "eXchange": G and S atomically
 * H means "sHift": T and Q atomically
 */

enum {
	CORE_VC8000E = 0,
	CORE_VC8000EJ = 1,
	CORE_CUTREE = 2,
	CORE_DEC400 = 3,
	CORE_MMU = 4,
	CORE_L2CACHE = 5,
	CORE_AXIFE = 6,
	CORE_APBFT = 7,
	CORE_MMU_1 = 8,
	CORE_AXIFE_1 = 9,
	CORE_MAX
};

typedef struct {
	u32 type_info;
	unsigned long offset[CORE_MAX];
	unsigned long regSize[CORE_MAX];
	int irq[CORE_MAX];
} SUBSYS_CORE_INFO;

typedef struct CoreWaitOut {
	u32 job_id[4];
	u32 irq_status[4];
	u32 irq_num;
} CORE_WAIT_OUT;

struct enc_config_parameter {
	u16 module_type; /* in vc8000e=0,cutree=1,vc8000d=2,jpege=3,jpegd=4 */
	u16 vcmd_core_num;
	u16 submodule_main_addr;
	u16 submodule_dec400_addr;
	u16 submodule_L2Cache_addr;
	u16 submodule_MMU_addr[2];
	u16 submodule_axife_addr[2];
	u16 config_status_cmdbuf_id;
	u32 vcmd_hw_version_id;
};

#define HANTRO_IOCG_HWOFFSET  _IOR(HANTRO_IOC_MAGIC,  3, unsigned long *)
#define HANTRO_IOCG_HWIOSIZE  _IOR(HANTRO_IOC_MAGIC,  4, unsigned int *)
#define HANTRO_IOC_CLI        _IO(HANTRO_IOC_MAGIC,  5)
#define HANTRO_IOC_STI        _IO(HANTRO_IOC_MAGIC,  6)
#define HANTRO_IOCX_VIRT2BUS  _IOWR(HANTRO_IOC_MAGIC, 7, unsigned long *)
#define HANTRO_IOCH_ARDRESET  _IO(HANTRO_IOC_MAGIC, 8)
#define HANTRO_IOCG_SRAMOFFSET  _IOR(HANTRO_IOC_MAGIC,  9, unsigned long *)
#define HANTRO_IOCG_SRAMEIOSIZE  _IOR(HANTRO_IOC_MAGIC,  10, unsigned int *)
#define HANTRO_IOCH_ENC_RESERVE  _IOR(HANTRO_IOC_MAGIC, 11, unsigned int *)
#define HANTRO_IOCH_ENC_RELEASE  _IOR(HANTRO_IOC_MAGIC, 12, unsigned int *)
#define HANTRO_IOCG_CORE_NUM     _IOR(HANTRO_IOC_MAGIC, 13, unsigned int *)
#define HANTRO_IOCG_CORE_INFO   _IOR(HANTRO_IOC_MAGIC, 14, SUBSYS_CORE_INFO *)
#define HANTRO_IOCG_CORE_WAIT    _IOR(HANTRO_IOC_MAGIC, 15, unsigned int *)
#define HANTRO_IOCG_ANYCORE_WAIT  _IOR(HANTRO_IOC_MAGIC, 16, CORE_WAIT_OUT *)

#define HANTRO_IOCH_GET_CMDBUF_PARAMETER\
	_IOWR(HANTRO_IOC_MAGIC, 25, struct cmdbuf_mem_parameter *)
#define HANTRO_IOCH_GET_CMDBUF_POOL_SIZE\
	_IOWR(HANTRO_IOC_MAGIC, 26, unsigned long)
#define HANTRO_IOCH_SET_CMDBUF_POOL_BASE\
	_IOWR(HANTRO_IOC_MAGIC, 27, unsigned long)
#define HANTRO_IOCH_GET_VCMD_PARAMETER\
	_IOWR(HANTRO_IOC_MAGIC, 28, struct enc_config_parameter *)
#define HANTRO_IOCH_LINK_RUN_CMDBUF   _IOR(HANTRO_IOC_MAGIC, 30, u16 *)
#define HANTRO_IOCH_WAIT_CMDBUF       _IOR(HANTRO_IOC_MAGIC, 31, u16 *)
#define HANTRO_IOCH_RELEASE_CMDBUF    _IOR(HANTRO_IOC_MAGIC, 32, u16 *)
#define HANTRO_IOCH_POLLING_CMDBUF    _IOR(HANTRO_IOC_MAGIC, 33, u16 *)
struct enc_hw_info {
	u32 hw_id;
	u32 cfg1val;
	u32 cfg2val;
	u32 cfg3val;
	u32 cfg4val;
	u32 cfg5val;
	u32 cfgaxi;
};
#define HANTRO_IOCH_GET_HWINFO_FROM_VCMD\
	_IOWR(HANTRO_IOC_MAGIC, 34, struct enc_hw_info *)
#define HANTRO_IOCH_GET_VCMD_ENABLE _IOWR(HANTRO_IOC_MAGIC, 50, unsigned long)

#define HANTRO_IOC_MAXNR 60
#define HANTRO_IOC_MMU_MAXNR 4
struct ENC_PRIVATE_DATA {
	int vcmd_type_core_num[MAX_VCMD_TYPE];
	u16 vcmd_position[MAX_VCMD_TYPE];
	u16 total_vcmd_core_num;
	int software_triger_abort;
	u16 enc_cmdbuf_used[TOTAL_DISCRETE_CMDBUF_NUM];
	u16 enc_cmdbuf_used_pos;
	u16 enc_cmdbuf_used_residual;
	bi_list_node *enc_global_cmdbuf_node[TOTAL_DISCRETE_CMDBUF_NUM];
	bi_list enc_global_process_manager;
	size_t enc_base_ddr_addr;
	struct vpu_pcie_info enc_pcie;
	struct vpu_vcmd_buff vcmd_buff;
	struct enc_hw_info hw_info;
	struct semaphore enc_vcmd_reserve_cmdbuf_sem[MAX_VCMD_TYPE];
	int enc_vcmd_type_core_num[MAX_VCMD_TYPE];
	/* 0:vcmd_buf_mem_pool; 1:vcmd_status_buf; 2:vcmd_registers */
	struct noncache_mem	enc_vcmd_mem_pool[3];
	spinlock_t enc_owner_lock_vcmd[MAX_VCMD_NUMBER];
	wait_queue_head_t enc_wait_queue_vcmd[MAX_VCMD_NUMBER];
	wait_queue_head_t enc_abort_queue_vcmd[MAX_VCMD_NUMBER];
	struct vpu_vcmd_buff *vcmd_pool;
	struct vpu_vcmd_buff *vcmd_reg;
};

struct ENC_PRIVATE_DATA *get_enc_private_handle(void);
void enc_vcmd_delink_cmdbuf(struct enc_hantrovcmd_dev *dev,
	bi_list_node *last_linked_cmdbuf_node);
void enc_vcmd_link_cmdbuf(struct enc_hantrovcmd_dev *dev,
	bi_list_node *last_linked_cmdbuf_node);
void enc_vcmd_start(struct enc_hantrovcmd_dev *dev,
	bi_list_node *first_linked_cmdbuf_node);
void hantroenc_vcmd_cleanup(void);
int enc_open(struct drm_file *filp);
long enc_ioctl(struct drm_file *filp, unsigned int cmd,
	void *arg);
int enc_vcmd_release(struct drm_file *filp, void *enc_priv);
int enc_link_and_run_cmdbuf(struct drm_file *filp,
	int cmdbuf_id, int cmdbuf_size, int *core_id);
unsigned int enc_wait_cmdbuf_ready(struct drm_file *filp, u32 cmdbuf_id,
	u32 *irq_status_ret);
int enc_vcmd_open(struct drm_file *filp, void **enc_priv,
	void *data);
int gbenc_cmdbuf_reserve(struct drm_file *filp, void *data);
long enc_release_cmdbuf(struct drm_file *filp, u16 cmdbuf_id);
int gb_venc_irq_handle(int irq_id);
void enc_resume(void);
void enc_suspend(void);
#endif



