#ifndef __GB_VPU_GEM_H__
#define __GB_VPU_GEM_H__
#include "common/gb_bo.h"
#include "vpu/vpu_comm/gb_vpu.h"

/* BO is expected to be accessed by the CPU */
#define GB_GEM_CPU_ACCESS		(1 << 0)
/* CPU access is not expected to work for this BO */
#define GB_GEM_NO_CPU_ACCESS	(1 << 1)

/** vpu submit params bo_handles = {cmdbuf_id, cmdbuf_size,};
 ** ENC_CMDBUF_SIZE 0x7d8;
 ** DEC_CMDBUF_SIZE 0x888;
 **/
enum vpu_submit_params {
	VPU_SUBMIT_CMD_ID = 0,
	VPU_SUBMIT_CMD_SIZE,
	VPU_SUBMIT_PARAMS_MAX,
};

int gbvpu_submit_ioctl(struct drm_file *filp, u64 bo_handles);
int gbvpu_wait_bo_ioctl(struct drm_file *filp, u32 cmdbuf_id);
void gbvpu_part_bo_save(struct gb_gem_object *gb_bo,
	struct drm_file *file_priv, struct gb_device *gbdev, int handle_index);
int gb_ioctl_vpu_vcmdbuf_free(int cmdbuf_id, struct drm_file *filp);

int gb_ioctl_vpu_vcmdbuf_resv(struct drm_device *dev, void *data,
	struct drm_file *filp);
int gb_ioctl_vpu_vcmd_open(struct drm_device *dev,
	void *data, struct drm_file *filp);
int gb_ioctl_vpu_vcmd_close(struct drm_device *dev,
	void *data, struct drm_file *filp);
int gb_ioctl_vpu_reg_ops(struct drm_device *dev,
	void *data, struct drm_file *filp);
void gb_vpu_postclose(struct drm_device *dev,
	struct drm_file *file);

int gb_ioctl_vpu_cmdbuf_free(struct drm_device *dev, void *data,
struct drm_file *filp);
int vcmd_bo_create(struct gb_device *gbdev,
	unsigned long size, int alignment, int initial_domain,
	u32 flags, bool kernel, int ip_type, struct vpu_vcmd_buff *vcmd_buff);
/*
int gb_vpu_vcmd_open(struct drm_device *dev, struct drm_file *filp,
		     void **dec_priv, void **dec1_priv, void **enc_priv);
*/
int gb_get_vpumm_size_info(void);

#endif

