#ifndef __GB_VPU_OBJECT_H__
#define __GB_VPU_OBJECT_H__

void gb_bo_unref(struct ttm_buffer_object *tbo);
int gb_bo_kmap(struct gbgpu_bo *bo, void **ptr);
void gb_bo_kunmap(struct gbvpu_bo *bo);
/**
 * radeon_bo_reserve - reserve bo
 * @bo:		bo structure
 * @no_intr:	don't return -ERESTARTSYS on pending signal
 *
 * Returns:
 * -ERESTARTSYS: A wait for the buffer to become unreserved was interrupted by
 * a signal. Release all buffer reservations and return to user-space.
 */
static inline int gb_bo_reserve(struct ttm_buffer_object	 *tbo, bool no_intr)
{
	int r;

	r = ttm_bo_reserve(tbo, !no_intr, false, NULL);
	if (unlikely(r != 0)) {
		if (r != -ERESTARTSYS)
			gb_printf(KERN_ERR, "%s-%d: %p reserve failed\n",
			 __func__, __LINE__, tbo);
		return r;
	}
	return 0;
}

static inline void gb_bo_unreserve(struct ttm_buffer_object	 *tbo)
{
	ttm_bo_unreserve(tbo);
}
#define dec_bo_to_gb_bo(dec_bo) \
	container_of(dec_bo, struct gb_gem_object, dec_base)

#endif
