/* SPDX-License-Identifier: GPL-3.0-or-later */
/*
 * Copyright (C) Xi'an Sietium Electronics Co.Ltd
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * jessy 20221019 Sietium
 */
#ifndef __VPU_VC8000E_VCMD_H__
#define __VPU_VC8000E_VCMD_H__
#include "common/gb_uk.h"
#include "vpu/vpu_comm/vpu_list.h"
#include "vpu/vpu_comm/vpu_vcmd_registers.h"
#include "vpu/vpu_comm/vpu_comm.h"
#include "vpu/vpu_comm/vpu_basetype.h"

/* VCMD CONFIGURATION BY CUSTOMER********/
//video encoder vcmd configuration
#define GB02MAC2274                      0x0
#define GB02MAC2275                      (GB02MAC4 * 4)
#define GB02MAC2277                      -1
#define GB02MAC2279                  0
#define GB02MAC2281             0x1000
#define GB02MAC2283           0XFFFF
#define GB02MAC2285          0XFFFF
#define GB02MAC2287             0XFFFF
#define GB02MAC2289             0XFFFF
#define GB02MAC2291           0XFFFF
#define GB02MAC2293           0XFFFF

#define GB02MAC2295                      0x91000
#define GB02MAC2297                      (GB02MAC4 * 4)
#define GB02MAC2299                      -1
#define GB02MAC2301                  0
#define GB02MAC2303             0x0000
#define GB02MAC2305           0XFFFF
#define GB02MAC2307          0XFFFF
#define GB02MAC2309              0XFFFF

#define GB02MAC2312                      0x92000
#define GB02MAC2313                      (GB02MAC4 * 4)
#define GB02MAC2315                      -1
#define GB02MAC2317                  0
#define GB02MAC2319             0x0000
#define GB02MAC2320           0XFFFF
#define GB02MAC2322          0XFFFF
#define GB02MAC2324              0XFFFF

#define GB02MAC2326                      0x93000
#define GB02MAC2327                      (GB02MAC4 * 4)
#define GB02MAC2329                      -1
#define GB02MAC2331                  0
#define GB02MAC2334             0x0000
#define GB02MAC2335           0XFFFF
#define GB02MAC2338          0XFFFF
#define GB02MAC2340              0XFFFF

/* video encoder cutree/IM  vcmd configuration */
#define GB02MAC2342                      0x94000
#define GB02MAC2344                      (GB02MAC4 * 4)
#define GB02MAC2346                      -1
#define GB02MAC2348                  1
#define GB02MAC2350             0x1000
#define GB02MAC2352           0XFFFF
#define GB02MAC2354          0XFFFF
#define GB02MAC2356             0XFFFF
#define GB02MAC2358             0XFFFF
#define GB02MAC2360           0XFFFF
#define GB02MAC2362           0XFFFF

#define GB02MAC2364                      0xa1000
#define GB02MAC2366                      (GB02MAC4 * 4)
#define GB02MAC2368                      -1
#define GB02MAC2370                  1
#define GB02MAC2372             0x0000
#define GB02MAC2374           0XFFFF
#define GB02MAC2376          0XFFFF
#define GB02MAC2378              0XFFFF

#define GB02MAC2380                      0xa2000
#define GB02MAC2382                      (GB02MAC4 * 4)
#define GB02MAC2384                      -1
#define GB02MAC2386                  1
#define GB02MAC2388             0x0000
#define GB02MAC2390           0XFFFF
#define GB02MAC2392          0XFFFF
#define GB02MAC2394              0XFFFF

#define GB02MAC2396                      0xa3000
#define GB02MAC2398                      (GB02MAC4 * 4)
#define GB02MAC2400                      -1
#define GB02MAC2402                  1
#define GB02MAC2404             0x0000
#define GB02MAC2406           0XFFFF
#define GB02MAC2408          0XFFFF
#define GB02MAC2410              0XFFFF

//video decoder vcmd configuration

#if 0
#define GB02MAC241                      0xb0000
#define GB02MAC243                      (GB02MAC4 * 4)
#define GB02MAC245                      -1
#define GB02MAC247                  2
#define GB02MAC249             0x0000
#define GB02MAC251           0XFFFF
#define GB02MAC253          0XFFFF
#define GB02MAC255              0XFFFF

#define GB02MAC258                      0xb1000
#define GB02MAC260                      (GB02MAC4 * 4)
#define GB02MAC261                      -1
#define GB02MAC263                  2
#define GB02MAC265             0x0000
#define GB02MAC267           0XFFFF
#define GB02MAC269          0XFFFF
#define GB02MAC271              0XFFFF

#define GB02MAC2422                      0xb2000
#define GB02MAC2424                      (GB02MAC4 * 4)
#define GB02MAC2426                      -1
#define GB02MAC2428                  2
#define GB02MAC2430             0x0000
#define GB02MAC2432           0XFFFF
#define GB02MAC2434          0XFFFF
#define GB02MAC2436              0XFFFF

#define GB02MAC2437                      0xb3000
#define GB02MAC2440                      (GB02MAC4 * 4)
#define GB02MAC2441                      -1
#define GB02MAC2443                  2
#define GB02MAC2445             0x0000
#define GB02MAC2447           0XFFFF
#define GB02MAC2449          0XFFFF
#define GB02MAC2451              0XFFFF

//JPEG encoder vcmd configuration

#define GB02MAC2453                      0x90000
#define GB02MAC2454                      (GB02MAC4 * 4)
#define GB02MAC2456                      -1
#define GB02MAC2458                  3
#define GB02MAC2460             0x1000
#define GB02MAC2462           0XFFFF //0X4000
#define GB02MAC2464          0XFFFF
#define GB02MAC2466             0XFFFF //0X2000
#define GB02MAC2467             0XFFFF
#define GB02MAC2469           0XFFFF //0X3000
#define GB02MAC2471           0XFFFF

#define GB02MAC2472                      0xC1000
#define GB02MAC2473                      (GB02MAC4 * 4)
#define GB02MAC2474                      -1
#define GB02MAC2475                  3
#define GB02MAC2476             0x0000
#define GB02MAC2477           0XFFFF
#define GB02MAC2478          0XFFFF
#define GB02MAC2479              0XFFFF

#define GB02MAC2480                      0xC2000
#define GB02MAC2481                      (GB02MAC4 * 4)
#define GB02MAC2482                      -1
#define GB02MAC2483                  3
#define GB02MAC2484             0x0000
#define GB02MAC2485           0XFFFF
#define GB02MAC2486          0XFFFF
#define GB02MAC2487              0XFFFF

#define GB02MAC2488                      0xC3000
#define GB02MAC2489                      (GB02MAC4 * 4)
#define GB02MAC2490                      -1
#define GB02MAC2491                  3
#define GB02MAC2492             0x0000
#define GB02MAC2493           0XFFFF
#define GB02MAC2494          0XFFFF
#define GB02MAC2495              0XFFFF

//JPEG decoder vcmd configuration

#define GB02MAC2496                      0xD0000
#define GB02MAC2497                      (GB02MAC4 * 4)
#define GB02MAC2498                      -1
#define GB02MAC2499                  4
#define GB02MAC2500             0x0000
#define GB02MAC2501           0XFFFF
#define GB02MAC2502          0XFFFF
#define GB02MAC2503              0XFFFF

#define GB02MAC2504                      0xD1000
#define GB02MAC2505                      (GB02MAC4 * 4)
#define GB02MAC2506                      -1
#define GB02MAC2507                  4
#define GB02MAC2508             0x0000
#define GB02MAC2509           0XFFFF
#define GB02MAC2510          0XFFFF
#define GB02MAC2511              0XFFFF

#define GB02MAC2512                      0xD2000
#define GB02MAC2513                      (GB02MAC4 * 4)
#define GB02MAC2514                      -1
#define GB02MAC2515                  4
#define GB02MAC2516             0x0000
#define GB02MAC2518           0XFFFF
#define GB02MAC2519          0XFFFF
#define GB02MAC2520              0XFFFF

#define GB02MAC2522                      0xD3000
#define GB02MAC2524                      (GB02MAC4 * 4)
#define GB02MAC2527                      -1
#define GB02MAC2529                  4
#define GB02MAC2531             0x0000
#define GB02MAC2533           0XFFFF
#define GB02MAC2535          0XFFFF
#define GB02MAC2537              0XFFFF
#endif
#define NETINT

/* Use 'k' as magic number */
#define GB02MAC2540  'k'
#define GB02MAC1065    'm'

/*
 * S means "Set" through a ptr,
 * T means "Tell" directly with the argument value
 * G means "Get": reply by setting through a pointer
 * Q means "Query": response is on the return value
 * X means "eXchange": G and S atomically
 * H means "sHift": T and Q atomically
 */

enum {
	CORE_VC8000E = 0,
	CORE_VC8000EJ = 1,
	CORE_CUTREE = 2,
	CORE_DEC400 = 3,
	CORE_MMU = 4,
	CORE_L2CACHE = 5,
	CORE_AXIFE = 6,
	CORE_APBFT = 7,
	CORE_MMU_1 = 8,
	CORE_AXIFE_1 = 9,
	CORE_MAX
};

typedef struct {
	u32 type_info;
	unsigned long offset[CORE_MAX];
	unsigned long regSize[CORE_MAX];
	int irq[CORE_MAX];
} SUBSYS_CORE_INFO;

typedef struct CoreWaitOut {
	u32 job_id[4];
	u32 irq_status[4];
	u32 irq_num;
} CORE_WAIT_OUT;

struct GB02STR183 {
	u16 module_type; /* in vc8000e=0,cutree=1,vc8000d=2,jpege=3,jpegd=4 */
	u16 vcmd_core_num;
	u16 submodule_main_addr;
	u16 submodule_dec400_addr;
	u16 submodule_L2Cache_addr;
	u16 submodule_MMU_addr[2];
	u16 submodule_axife_addr[2];
	u16 config_status_cmdbuf_id;
	u32 vcmd_hw_version_id;
};

#define HANTRO_IOCG_HWOFFSET  _IOR(GB02MAC2540,  3, unsigned long *)
#define HANTRO_IOCG_HWIOSIZE  _IOR(GB02MAC2540,  4, unsigned int *)
#define HANTRO_IOC_CLI        _IO(GB02MAC2540,  5)
#define HANTRO_IOC_STI        _IO(GB02MAC2540,  6)
#define HANTRO_IOCX_VIRT2BUS  _IOWR(GB02MAC2540, 7, unsigned long *)
#define HANTRO_IOCH_ARDRESET  _IO(GB02MAC2540, 8)
#define HANTRO_IOCG_SRAMOFFSET  _IOR(GB02MAC2540,  9, unsigned long *)
#define HANTRO_IOCG_SRAMEIOSIZE  _IOR(GB02MAC2540,  10, unsigned int *)
#define HANTRO_IOCH_ENC_RESERVE  _IOR(GB02MAC2540, 11, unsigned int *)
#define HANTRO_IOCH_ENC_RELEASE  _IOR(GB02MAC2540, 12, unsigned int *)
#define HANTRO_IOCG_CORE_NUM     _IOR(GB02MAC2540, 13, unsigned int *)
#define HANTRO_IOCG_CORE_INFO   _IOR(GB02MAC2540, 14, SUBSYS_CORE_INFO *)
#define HANTRO_IOCG_CORE_WAIT    _IOR(GB02MAC2540, 15, unsigned int *)
#define HANTRO_IOCG_ANYCORE_WAIT  _IOR(GB02MAC2540, 16, CORE_WAIT_OUT *)

#define HANTRO_IOCH_GET_CMDBUF_PARAMETER\
	_IOWR(GB02MAC2540, 25, struct GB02STR16 *)
#define HANTRO_IOCH_GET_CMDBUF_POOL_SIZE\
	_IOWR(GB02MAC2540, 26, unsigned long)
#define HANTRO_IOCH_SET_CMDBUF_POOL_BASE\
	_IOWR(GB02MAC2540, 27, unsigned long)
#define HANTRO_IOCH_GET_VCMD_PARAMETER\
	_IOWR(GB02MAC2540, 28, struct GB02STR183 *)
#define HANTRO_IOCH_LINK_RUN_CMDBUF   _IOR(GB02MAC2540, 30, u16 *)
#define HANTRO_IOCH_WAIT_CMDBUF       _IOR(GB02MAC2540, 31, u16 *)
#define HANTRO_IOCH_RELEASE_CMDBUF    _IOR(GB02MAC2540, 32, u16 *)
#define HANTRO_IOCH_POLLING_CMDBUF    _IOR(GB02MAC2540, 33, u16 *)
struct GB02STR185 {
	u32 hw_id;
	u32 cfg1val;
	u32 cfg2val;
	u32 cfg3val;
	u32 cfg4val;
	u32 cfg5val;
	u32 cfgaxi;
};
#define HANTRO_IOCH_GET_HWINFO_FROM_VCMD\
	_IOWR(GB02MAC2540, 34, struct GB02STR185 *)
#define HANTRO_IOCH_GET_VCMD_ENABLE _IOWR(GB02MAC2540, 50, unsigned long)

#define GB02MAC2553 60
#define GB02MAC1066 4
struct GB02STR186 {
	int vcmd_type_core_num[MAX_VCMD_TYPE];
	u16 vcmd_position[MAX_VCMD_TYPE];
	u16 total_vcmd_core_num;
	int software_triger_abort;
	u16 enc_cmdbuf_used[GB02MAC158];
	u16 enc_cmdbuf_used_pos;
	u16 enc_cmdbuf_used_residual;
	bi_list_node *enc_global_cmdbuf_node[GB02MAC158];
	bi_list enc_global_process_manager;
	size_t enc_base_ddr_addr;
	struct GB02STR21 enc_pcie;
	struct GB02STR3 vcmd_buff;
	struct GB02STR185 hw_info;
	struct semaphore enc_vcmd_reserve_cmdbuf_sem[MAX_VCMD_TYPE];
	int enc_vcmd_type_core_num[MAX_VCMD_TYPE];
	/* 0:vcmd_buf_mem_pool; 1:vcmd_status_buf; 2:vcmd_registers */
	struct GB02STR14	enc_vcmd_mem_pool[3];
	spinlock_t enc_owner_lock_vcmd[GB02MAC152];
	wait_queue_head_t enc_wait_queue_vcmd[GB02MAC152];
	wait_queue_head_t enc_abort_queue_vcmd[GB02MAC152];
	struct GB02STR3 *vcmd_pool;
	struct GB02STR3 *vcmd_reg;
};

struct GB02STR186 *GB02FUNC1624(void);
void GB02FUNC1586(struct GB02STR6 *dev,
	bi_list_node *last_linked_cmdbuf_node);
void GB02FUNC1527(struct GB02STR6 *dev,
	bi_list_node *last_linked_cmdbuf_node);
void GB02FUNC1535(struct GB02STR6 *dev,
	bi_list_node *first_linked_cmdbuf_node);
void GB02FUNC1643(void);
int enc_open(struct drm_file *filp);
long GB02FUNC1619(struct drm_file *filp, unsigned int cmd,
	void *arg);
int GB02FUNC1597(struct drm_file *filp, void *enc_priv);
int GB02FUNC1543(struct drm_file *filp,
	int cmdbuf_id, int cmdbuf_size, int *core_id);
unsigned int GB02FUNC1551(struct drm_file *filp, u32 cmdbuf_id,
	u32 *irq_status_ret);
int GB02FUNC1590(struct drm_file *filp, void **enc_priv,
	void *data);
int GB02FUNC1617(struct drm_file *filp, void *data);
long GB02FUNC1614(struct drm_file *filp, u16 cmdbuf_id);
int GB02FUNC1637(int irq_id);
void GB02FUNC1576(void);
void GB02FUNC1578(void);
#endif



